<!--
    Copyright © 2016 - 2020 Stefan Berg <isbeorn86+NINA@googlemail.com> and the N.I.N.A. contributors 

    This file is part of N.I.N.A. - Nighttime Imaging 'N' Astronomy.

    This Source Code Form is subject to the terms of the Mozilla Public
    License, v. 2.0. If a copy of the MPL was not distributed with this
    file, You can obtain one at http://mozilla.org/MPL/2.0/.
-->
<UserControl
    x:Class="NINA.View.SkyAtlasView"
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
    xmlns:i="http://schemas.microsoft.com/expression/2010/interactivity"
    xmlns:local="clr-namespace:NINA.View"
    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
    xmlns:ninactrl="clr-namespace:NINACustomControlLibrary;assembly=NINACustomControlLibrary"
    xmlns:ns="clr-namespace:NINA.Locale"
    xmlns:util="clr-namespace:NINA.Utility"
    xmlns:vm="clr-namespace:NINA.ViewModel"
    d:DesignHeight="300"
    d:DesignWidth="300"
    mc:Ignorable="d">
    <Grid>
        <Grid.ColumnDefinitions>
            <ColumnDefinition />
            <ColumnDefinition Width="4*" />
        </Grid.ColumnDefinitions>

        <Grid Grid.Column="0">
            <Grid.RowDefinitions>
                <RowDefinition Height="2*" />
                <RowDefinition Height="270" />
                <RowDefinition Height="60" />
            </Grid.RowDefinitions>
            <!--  Filter area  -->
            <Border BorderBrush="{StaticResource BorderBrush}" BorderThickness="0,0,0,1">
                <ScrollViewer VerticalScrollBarVisibility="Auto">
                    <StackPanel Margin="5">
                        <Grid HorizontalAlignment="Stretch">
                            <ninactrl:HintTextBox
                                HorizontalAlignment="Stretch"
                                VerticalContentAlignment="Center"
                                DockPanel.Dock="Left"
                                Foreground="{StaticResource PrimaryBrush}"
                                HintText="{ns:Loc LblObjectNameHint}"
                                Text="{Binding SearchObjectName, UpdateSourceTrigger=PropertyChanged}">
                                <TextBox.InputBindings>
                                    <KeyBinding Key="Enter" Command="{Binding Path=SearchCommand}" />
                                </TextBox.InputBindings>
                            </ninactrl:HintTextBox>

                            <Button
                                Width="20"
                                Height="20"
                                HorizontalAlignment="Right"
                                Command="{Binding ResetFiltersCommand}"
                                DockPanel.Dock="Right"
                                ToolTip="{ns:Loc LblClear}">
                                <Path
                                    Margin="5"
                                    Data="{StaticResource ResetSVG}"
                                    Fill="{StaticResource ButtonForegroundDisabledBrush}"
                                    Stretch="Uniform" />
                            </Button>
                        </Grid>

                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblObjectType}">
                            <ScrollViewer Grid.Column="1" MaxHeight="300">
                                <ItemsControl ItemsSource="{Binding ObjectTypes}">
                                    <ItemsControl.ItemTemplate>
                                        <DataTemplate>
                                            <StackPanel Orientation="Horizontal">
                                                <CheckBox
                                                    Width="20"
                                                    Height="20"
                                                    IsChecked="{Binding Selected}"
                                                    Style="{StaticResource CheckmarkAndEmptyCheckbox}" />
                                                <TextBlock Margin="10,0,0,0" Text="{Binding Name, Converter={StaticResource ValueToLocaleConverter}, ConverterParameter=LblObjectType_}" />
                                            </StackPanel>
                                        </DataTemplate>
                                    </ItemsControl.ItemTemplate>
                                </ItemsControl>
                            </ScrollViewer>
                        </Expander>
                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblConstellation}">
                            <ComboBox ItemsSource="{Binding Constellations}" SelectedItem="{Binding SelectedConstellation}">
                                <ComboBox.ItemTemplate>
                                    <DataTemplate>
                                        <TextBlock Text="{Binding Converter={StaticResource ValueToLocaleConverter}, ConverterParameter=LblConstellation_}" />
                                    </DataTemplate>
                                </ComboBox.ItemTemplate>
                            </ComboBox>
                        </Expander>
                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblCoordinates}">
                            <StackPanel>
                                <StackPanel>
                                    <TextBlock Text="{ns:Loc LblRightAscension}" />
                                    <UniformGrid Columns="2">
                                        <TextBlock Text="{ns:Loc LblFrom}" />
                                        <ComboBox
                                            DisplayMemberPath="Value"
                                            ItemsSource="{Binding RAFrom}"
                                            SelectedValue="{Binding SelectedRAFrom}"
                                            SelectedValuePath="Key" />
                                    </UniformGrid>
                                    <UniformGrid Columns="2">
                                        <TextBlock Text="{ns:Loc LblThrough}" />
                                        <ComboBox
                                            DisplayMemberPath="Value"
                                            ItemsSource="{Binding RAThrough}"
                                            SelectedValue="{Binding SelectedRAThrough}"
                                            SelectedValuePath="Key" />
                                    </UniformGrid>
                                </StackPanel>

                                <StackPanel>
                                    <TextBlock Text="{ns:Loc LblDeclination}" />
                                    <UniformGrid Columns="2">
                                        <TextBlock Text="{ns:Loc LblFrom}" />
                                        <ComboBox
                                            DisplayMemberPath="Value"
                                            ItemsSource="{Binding DecFrom}"
                                            SelectedValue="{Binding SelectedDecFrom}"
                                            SelectedValuePath="Key" />
                                    </UniformGrid>
                                    <UniformGrid Columns="2">
                                        <TextBlock Text="{ns:Loc LblThrough}" />
                                        <ComboBox
                                            DisplayMemberPath="Value"
                                            ItemsSource="{Binding DecThrough}"
                                            SelectedValue="{Binding SelectedDecThrough}"
                                            SelectedValuePath="Key" />
                                    </UniformGrid>
                                </StackPanel>
                            </StackPanel>
                        </Expander>
                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblSurfaceBrightness}">
                            <StackPanel>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblFrom}" />
                                    <ComboBox ItemsSource="{Binding BrightnessFrom}" SelectedItem="{Binding SelectedBrightnessFrom}" />
                                </UniformGrid>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblThrough}" />
                                    <ComboBox ItemsSource="{Binding BrightnessThrough}" SelectedItem="{Binding SelectedBrightnessThrough}" />
                                </UniformGrid>
                            </StackPanel>
                        </Expander>
                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblApparentSize}">
                            <StackPanel>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblFrom}" />
                                    <ComboBox
                                        DisplayMemberPath="Value"
                                        ItemsSource="{Binding SizesFrom}"
                                        SelectedValue="{Binding SelectedSizeFrom}"
                                        SelectedValuePath="Key" />
                                </UniformGrid>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblThrough}" />
                                    <ComboBox
                                        DisplayMemberPath="Value"
                                        ItemsSource="{Binding SizesThrough}"
                                        SelectedValue="{Binding SelectedSizeThrough}"
                                        SelectedValuePath="Key" />
                                </UniformGrid>
                            </StackPanel>
                        </Expander>
                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblApparentMagnitude}">
                            <StackPanel>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblFrom}" />
                                    <ComboBox ItemsSource="{Binding MagnitudesFrom}" SelectedItem="{Binding SelectedMagnitudeFrom}" />
                                </UniformGrid>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblThrough}" />
                                    <ComboBox ItemsSource="{Binding MagnitudesThrough}" SelectedItem="{Binding SelectedMagnitudeThrough}" />
                                </UniformGrid>
                            </StackPanel>
                        </Expander>

                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblMinimumAltitude}">
                            <StackPanel>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblFrom}" />
                                    <ComboBox
                                        ItemStringFormat="yyyy-MM-dd HH:mm"
                                        ItemsSource="{Binding AltitudeTimesFrom}"
                                        SelectedItem="{Binding SelectedAltitudeTimeFrom}" />
                                </UniformGrid>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblThrough}" />
                                    <ComboBox
                                        ItemStringFormat="yyyy-MM-dd HH:mm"
                                        ItemsSource="{Binding AltitudeTimesThrough}"
                                        SelectedItem="{Binding SelectedAltitudeTimeThrough}" />
                                </UniformGrid>
                                <UniformGrid Columns="2">
                                    <TextBlock Text="{ns:Loc LblAltitude}" />
                                    <ComboBox
                                        DisplayMemberPath="Value"
                                        ItemsSource="{Binding MinimumAltitudeDegrees}"
                                        SelectedValue="{Binding SelectedMinimumAltitudeDegrees}"
                                        SelectedValuePath="Key" />
                                </UniformGrid>
                            </StackPanel>
                        </Expander>

                        <Expander
                            BorderBrush="{StaticResource BorderBrush}"
                            BorderThickness="0,0,0,1"
                            Header="{ns:Loc LblReferenceDate}">
                            <UniformGrid Columns="2">
                                <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblReferenceDate}" />
                                <DatePicker SelectedDate="{Binding SelectedDate}" />
                            </UniformGrid>
                        </Expander>

                        <UniformGrid Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblOrderBy}" />
                            <ComboBox ItemsSource="{Binding Source={util:EnumBindingSource {x:Type vm:SkyAtlasOrderByFieldsEnum}}}" SelectedItem="{Binding OrderByField}" />
                        </UniformGrid>
                        <UniformGrid Columns="2">
                            <Grid />
                            <ComboBox ItemsSource="{Binding Source={util:EnumBindingSource {x:Type vm:SkyAtlasOrderByDirectionEnum}}}" SelectedItem="{Binding OrderByDirection}" />
                        </UniformGrid>

                        <UniformGrid Margin="0,5,0,5" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblItemsPerPage}" />
                            <TextBox Text="{Binding PageSize}" />
                        </UniformGrid>

                        <ninactrl:CancellableButton
                            Height="40"
                            Margin="5"
                            ButtonText="{ns:Loc LblSearch}"
                            CancelButtonImage="{StaticResource CancelSVG}"
                            CancelCommand="{Binding CancelSearchCommand}"
                            Command="{Binding SearchCommand}"
                            Visibility="{Binding SearchCommand, Converter={StaticResource NullToVisibilityCollapsedConverter}}" />
                    </StackPanel>
                </ScrollViewer>
            </Border>

            <Border
                Grid.Row="1"
                Margin="0,5,0,0"
                BorderBrush="{StaticResource BorderBrush}"
                BorderThickness="0,1,0,1">
                <StackPanel>
                    <Grid Margin="0,5,0,0">
                        <Path
                            Width="49"
                            Height="49"
                            Data="{StaticResource NewMoonSVG}"
                            Fill="Yellow"
                            Stretch="Uniform" />
                        <Path
                            Width="50"
                            Height="50"
                            Data="{Binding MoonPhase, Converter={StaticResource MoonPhaseToGeometryConverter}}"
                            Fill="Black"
                            Stretch="Uniform" />
                    </Grid>

                    <Border
                        MinHeight="30"
                        BorderBrush="{StaticResource BorderBrush}"
                        BorderThickness="0">
                        <UniformGrid VerticalAlignment="Center" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblIllumination}" />
                            <TextBlock Text="{Binding Illumination, StringFormat={}{0:P2}}" />
                        </UniformGrid>
                    </Border>

                    <Border
                        MinHeight="30"
                        BorderBrush="{StaticResource BorderBrush}"
                        BorderThickness="0">
                        <UniformGrid VerticalAlignment="Center" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblMoonRise}" />
                            <TextBlock Text="{Binding MoonRiseAndSet.Rise, StringFormat={}{0:HH:mm}}" />
                        </UniformGrid>
                    </Border>

                    <Border
                        MinHeight="30"
                        BorderBrush="{StaticResource BorderBrush}"
                        BorderThickness="0">
                        <UniformGrid VerticalAlignment="Center" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblMoonSet}" />
                            <TextBlock Text="{Binding MoonRiseAndSet.Set, StringFormat={}{0:HH:mm}}" />
                        </UniformGrid>
                    </Border>

                    <Border
                        MinHeight="30"
                        BorderBrush="{StaticResource BorderBrush}"
                        BorderThickness="0">
                        <UniformGrid VerticalAlignment="Center" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblDawn}" />
                            <TextBlock Text="{Binding TwilightRiseAndSet.Rise, StringFormat={}{0:HH:mm}}" />
                        </UniformGrid>
                    </Border>

                    <Border
                        MinHeight="30"
                        BorderBrush="{StaticResource BorderBrush}"
                        BorderThickness="0">
                        <UniformGrid VerticalAlignment="Center" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblSunRise}" />
                            <TextBlock Text="{Binding SunRiseAndSet.Rise, StringFormat={}{0:HH:mm}}" />
                        </UniformGrid>
                    </Border>

                    <Border
                        MinHeight="30"
                        BorderBrush="{StaticResource BorderBrush}"
                        BorderThickness="0">
                        <UniformGrid VerticalAlignment="Center" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblSunSet}" />
                            <TextBlock Text="{Binding SunRiseAndSet.Set, StringFormat={}{0:HH:mm}}" />
                        </UniformGrid>
                    </Border>

                    <Border
                        MinHeight="30"
                        BorderBrush="{StaticResource BorderBrush}"
                        BorderThickness="0">
                        <UniformGrid VerticalAlignment="Center" Columns="2">
                            <TextBlock VerticalAlignment="Center" Text="{ns:Loc LblDusk}" />
                            <TextBlock Text="{Binding TwilightRiseAndSet.Set, StringFormat={}{0:HH:mm}}" />
                        </UniformGrid>
                    </Border>
                </StackPanel>
            </Border>
            <Border
                Grid.Row="2"
                Margin="0,5,0,0"
                BorderBrush="{StaticResource BorderBrush}"
                BorderThickness="0,1,0,0">

                <StackPanel VerticalAlignment="Center" Orientation="Vertical">
                    <TextBlock Text="{ns:Loc LblDataProvidedBy}" />
                    <TextBlock>
                        <Hyperlink NavigateUri="https://www.saguaroastro.org/sac-downloads/" RequestNavigate="Hyperlink_RequestNavigate">
                            Saguaro Astronomy Club Database version 8.1
                        </Hyperlink>
                    </TextBlock>
                </StackPanel>
            </Border>
        </Grid>

        <ninactrl:LoadingControl
            Grid.Column="1"
            MaxWidth="100"
            MaxHeight="100"
            HorizontalAlignment="Center"
            VerticalAlignment="Center"
            LoadingImageBrush="{StaticResource PrimaryBrush}"
            Visibility="{Binding SearchCommand.Execution.IsNotCompleted, Converter={StaticResource BooleanToVisibilityCollapsedConverter}, FallbackValue=Collapsed}" />
        <Path
            Grid.Column="1"
            Width="100"
            Height="100"
            Margin="5"
            HorizontalAlignment="Center"
            VerticalAlignment="Center"
            Data="{StaticResource MapSVG}"
            Fill="{StaticResource ButtonForegroundDisabledBrush}"
            Opacity="0.2"
            Stretch="Uniform"
            Visibility="{Binding SearchCommand.Execution.IsNotCompleted, Converter={StaticResource InverseBoolToVisibilityConverter}, FallbackValue=Visible}" />

        <!--  Search result area  -->
        <Grid Grid.Column="1" DataContext="{Binding SearchResult}">
            <Grid.RowDefinitions>
                <RowDefinition />
                <RowDefinition Height="Auto" />
            </Grid.RowDefinitions>

            <DataGrid
                AutoGenerateColumns="False"
                HeadersVisibility="Column"
                HorizontalScrollBarVisibility="Disabled"
                ItemsSource="{Binding ItemPage, IsAsync=True}"
                SelectedItem="{Binding SelectedItem}"
                SelectionMode="Single">
                <DataGrid.Resources>
                    <Style x:Key="myHeaderStyle" TargetType="{x:Type GridViewColumnHeader}">
                        <Setter Property="Visibility" Value="Collapsed" />
                    </Style>
                </DataGrid.Resources>
                <DataGrid.Columns>
                    <DataGridTemplateColumn
                        Width="*"
                        CanUserSort="False"
                        Header="{ns:Loc LblName}">
                        <DataGridTemplateColumn.CellTemplate>
                            <DataTemplate>
                                <ItemsControl Margin="0,5,0,0" ItemsSource="{Binding AlsoKnownAs}" />
                            </DataTemplate>
                        </DataGridTemplateColumn.CellTemplate>
                    </DataGridTemplateColumn>
                    <DataGridTemplateColumn
                        Width="320"
                        CanUserSort="False"
                        Header="{ns:Loc LblDetails}">
                        <DataGridTemplateColumn.CellTemplate>
                            <DataTemplate>
                                <Border>
                                    <Border.Background>
                                        <ImageBrush
                                            x:Name="PART_Image"
                                            ImageSource="{Binding Image, IsAsync=True}"
                                            RenderOptions.BitmapScalingMode="LowQuality"
                                            Stretch="Uniform" />
                                    </Border.Background>
                                    <Grid>
                                        <Grid.RowDefinitions>
                                            <RowDefinition />
                                            <RowDefinition />
                                        </Grid.RowDefinitions>

                                        <!--  will be displayed when no image is available  -->
                                        <TextBlock
                                            x:Name="PART_Textblock"
                                            Grid.RowSpan="2"
                                            HorizontalAlignment="Center"
                                            VerticalAlignment="Center"
                                            Foreground="{StaticResource ButtonForegroundDisabledBrush}"
                                            Text="{ns:Loc LblNoImage}"
                                            Visibility="Collapsed" />

                                        <StackPanel VerticalAlignment="Top">

                                            <Grid>
                                                <StackPanel
                                                    Margin="0,6,0,6"
                                                    HorizontalAlignment="Left"
                                                    VerticalAlignment="Center"
                                                    Orientation="Horizontal">
                                                    <TextBlock Foreground="LightGray" Text="{ns:Loc LblRA}" />
                                                    <TextBlock
                                                        MinWidth="40"
                                                        Margin="5,0,0,0"
                                                        VerticalAlignment="Center"
                                                        Foreground="LightGray"
                                                        Text="{Binding Coordinates.RAString}" />
                                                </StackPanel>
                                                <StackPanel
                                                    Margin="0,6,0,6"
                                                    HorizontalAlignment="Right"
                                                    VerticalAlignment="Center"
                                                    Orientation="Horizontal">
                                                    <TextBlock Foreground="LightGray" Text="{ns:Loc LblType}" />
                                                    <TextBlock
                                                        MinWidth="40"
                                                        Margin="5,0,0,0"
                                                        VerticalAlignment="Center"
                                                        Foreground="LightGray"
                                                        Text="{Binding DSOType}" />
                                                </StackPanel>
                                            </Grid>

                                            <Grid>
                                                <StackPanel
                                                    Margin="0,6,0,6"
                                                    HorizontalAlignment="Left"
                                                    VerticalAlignment="Center"
                                                    Orientation="Horizontal">
                                                    <TextBlock Foreground="LightGray" Text="{ns:Loc LblDec}" />
                                                    <TextBlock
                                                        MinWidth="40"
                                                        Margin="5,0,0,0"
                                                        VerticalAlignment="Center"
                                                        Foreground="LightGray"
                                                        Text="{Binding Coordinates.DecString}" />
                                                </StackPanel>
                                                <StackPanel
                                                    Margin="0,6,0,6"
                                                    HorizontalAlignment="Right"
                                                    VerticalAlignment="Center"
                                                    Orientation="Horizontal">
                                                    <TextBlock Foreground="LightGray" Text="{ns:Loc LblConstellation}" />
                                                    <TextBlock
                                                        MinWidth="40"
                                                        Margin="5,0,0,0"
                                                        VerticalAlignment="Center"
                                                        Foreground="LightGray"
                                                        Text="{Binding Constellation}" />
                                                </StackPanel>
                                            </Grid>
                                        </StackPanel>
                                        <StackPanel Grid.Row="1" VerticalAlignment="Bottom">

                                            <Grid>
                                                <StackPanel
                                                    Margin="0,6,0,6"
                                                    HorizontalAlignment="Left"
                                                    VerticalAlignment="Center"
                                                    Orientation="Horizontal">
                                                    <Path
                                                        Width="20"
                                                        Height="20"
                                                        Data="{StaticResource LightBulbSVG}"
                                                        Fill="LightGray"
                                                        Stretch="Uniform"
                                                        ToolTip="{ns:Loc LblMagnitude}" />
                                                    <TextBlock
                                                        MinWidth="40"
                                                        Margin="5,0,0,0"
                                                        VerticalAlignment="Center"
                                                        Foreground="LightGray"
                                                        Text="{Binding Magnitude}" />
                                                </StackPanel>
                                                <StackPanel
                                                    Margin="0,6,0,6"
                                                    HorizontalAlignment="Center"
                                                    VerticalAlignment="Center"
                                                    Orientation="Horizontal">
                                                    <Path
                                                        Width="20"
                                                        Height="20"
                                                        Data="{StaticResource BrightnessSVG}"
                                                        Fill="LightGray"
                                                        Stretch="Uniform"
                                                        ToolTip="{ns:Loc LblSurfaceBrightness}" />
                                                    <TextBlock
                                                        MinWidth="40"
                                                        Margin="5,0,0,0"
                                                        VerticalAlignment="Center"
                                                        Foreground="LightGray"
                                                        Text="{Binding SurfaceBrightness}" />
                                                </StackPanel>
                                                <StackPanel
                                                    Margin="0,6,0,6"
                                                    HorizontalAlignment="Right"
                                                    VerticalAlignment="Center"
                                                    Orientation="Horizontal">
                                                    <Path
                                                        Width="20"
                                                        Height="20"
                                                        Margin="5"
                                                        Data="{StaticResource Stretch}"
                                                        Fill="LightGray"
                                                        Stretch="Uniform"
                                                        ToolTip="{ns:Loc LblSize}" />
                                                    <TextBlock
                                                        MinWidth="40"
                                                        Margin="5,0,0,0"
                                                        VerticalAlignment="Center"
                                                        Foreground="LightGray"
                                                        Text="{Binding Size, Converter={StaticResource ArcsecToLabelConverter}, Mode=OneWay}" />
                                                </StackPanel>
                                            </Grid>
                                        </StackPanel>
                                    </Grid>
                                </Border>
                                <DataTemplate.Triggers>
                                    <DataTrigger Binding="{Binding ImageSource, ElementName=PART_Image}" Value="{x:Null}">
                                        <Setter TargetName="PART_Textblock" Property="Visibility" Value="Visible" />
                                        <!--  Here is the 'override' content  -->
                                    </DataTrigger>
                                </DataTemplate.Triggers>
                            </DataTemplate>
                        </DataGridTemplateColumn.CellTemplate>
                    </DataGridTemplateColumn>

                    <DataGridTemplateColumn
                        Width="3*"
                        CanUserSort="False"
                        Header="{ns:Loc LblAltitude}">
                        <DataGridTemplateColumn.CellTemplate>
                            <DataTemplate>
                                <local:AltitudeChart DataContext="{Binding}" />
                            </DataTemplate>
                        </DataGridTemplateColumn.CellTemplate>
                    </DataGridTemplateColumn>

                    <DataGridTemplateColumn
                        Width="1.5*"
                        CanUserSort="False"
                        Header="">
                        <DataGridTemplateColumn.CellTemplate>
                            <DataTemplate>
                                <UniformGrid
                                    HorizontalAlignment="Stretch"
                                    VerticalAlignment="Center"
                                    Columns="1"
                                    Rows="3">
                                    <Button
                                        MinHeight="40"
                                        Margin="5"
                                        HorizontalAlignment="Stretch"
                                        Command="{Binding DataContext.SetSequenceCoordinatesCommand, RelativeSource={RelativeSource AncestorType=local:SkyAtlasView}}">
                                        <TextBlock
                                            Foreground="{StaticResource ButtonForegroundBrush}"
                                            Text="{ns:Loc LblSetAsSequenceTarget}"
                                            TextWrapping="Wrap" />
                                    </Button>
                                    <Button
                                        MinHeight="40"
                                        Margin="5"
                                        HorizontalAlignment="Stretch"
                                        Command="{Binding DataContext.SetFramingAssistantCoordinatesCommand, RelativeSource={RelativeSource AncestorType=local:SkyAtlasView}}">
                                        <TextBlock
                                            Foreground="{StaticResource ButtonForegroundBrush}"
                                            Text="{ns:Loc LblSetForFramingAssistant}"
                                            TextWrapping="Wrap" />
                                    </Button>
                                    <Button
                                        MinHeight="40"
                                        Margin="5"
                                        HorizontalAlignment="Stretch"
                                        Command="{Binding DataContext.SlewToCoordinatesCommand, RelativeSource={RelativeSource AncestorType=local:SkyAtlasView}}">
                                        <TextBlock Foreground="{StaticResource ButtonForegroundBrush}" Text="{ns:Loc LblSlew}" />
                                    </Button>
                                </UniformGrid>
                            </DataTemplate>
                        </DataGridTemplateColumn.CellTemplate>
                    </DataGridTemplateColumn>
                </DataGrid.Columns>
            </DataGrid>
            <Grid Grid.Row="1" Visibility="{Binding Converter={StaticResource NullToVisibilityCollapsedConverter}}">
                <Grid.ColumnDefinitions>
                    <ColumnDefinition />
                    <ColumnDefinition Width="Auto" />
                </Grid.ColumnDefinitions>
                <StackPanel
                    Height="35"
                    Margin="5,0,5,0"
                    HorizontalAlignment="Center"
                    Orientation="Horizontal">
                    <Button
                        Width="35"
                        Margin="5,2.5,0,2.5"
                        Command="{Binding FirstPageCommand}"
                        Content="&lt;|" />
                    <Button
                        Width="35"
                        Margin="5,2.5,0,2.5"
                        Command="{Binding PrevPageCommand}"
                        Content="&lt;&lt;" />
                    <ComboBox
                        Margin="5,2.5,0,2.5"
                        ItemsSource="{Binding Pages}"
                        SelectedValue="{Binding CurrentPage, Mode=TwoWay}">
                        <i:Interaction.Triggers>
                            <i:EventTrigger EventName="SelectionChanged">
                                <i:InvokeCommandAction Command="{Binding PageByNumberCommand}" />
                            </i:EventTrigger>
                        </i:Interaction.Triggers>
                    </ComboBox>
                    <TextBlock
                        Margin="5,0,0,0"
                        VerticalAlignment="Center"
                        Text="{ns:Loc LblOf}" />
                    <TextBlock
                        Margin="5,0,0,0"
                        VerticalAlignment="Center"
                        Text="{Binding Pages.Count}" />
                    <Button
                        Width="35"
                        Margin="5,2.5,0,2.5"
                        Command="{Binding NextPageCommand}"
                        Content="&gt;&gt;" />
                    <Button
                        Width="35"
                        Margin="5,2.5,0,2.5"
                        Command="{Binding LastPageCommand}"
                        Content="|&gt;" />
                </StackPanel>
                <Border
                    Grid.Column="1"
                    MinWidth="220"
                    BorderBrush="{StaticResource BorderBrush}"
                    BorderThickness="1,0,0,0">
                    <StackPanel
                        Margin="5,0,5,0"
                        HorizontalAlignment="Center"
                        Orientation="Horizontal">
                        <TextBlock VerticalAlignment="Center" Text="{Binding PageStartIndex}" />
                        <TextBlock
                            Margin="5,0,5,0"
                            VerticalAlignment="Center"
                            Text="{ns:Loc LblTo}" />
                        <TextBlock VerticalAlignment="Center" Text="{Binding PageEndIndex}" />
                        <TextBlock
                            Margin="5,0,5,0"
                            VerticalAlignment="Center"
                            Text="{ns:Loc LblOf}" />
                        <TextBlock VerticalAlignment="Center" Text="{Binding Count}" />
                    </StackPanel>
                </Border>
            </Grid>
        </Grid>
    </Grid>
</UserControl>
